﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Threading;
using System.Diagnostics;
using Abhishek = System.Drawing;

namespace UncommonTestSample
{
    public partial class Documented : Form
    {
        public volatile int i;
        public readonly int readsecond;
        public Documented()
        {
            InitializeComponent();
            readsecond = DateTime.Now.Second;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var yieldoutput = this.getYeild();
            MessageBox.Show("Yield returns : " + yieldoutput.ToList<string>().Count + " elements.");

            string str = "this is my string";
            string encstr = Convert.ToBase64String(System.Text.Encoding.Unicode.GetBytes(str));
            string decstr = System.Text.Encoding.Unicode.GetString(Convert.FromBase64String(encstr));
        }

        public IEnumerable<string> getYeild()
        {
            List<string> lst = new List<string>();
            lst.Add("Abhishek");
            lst.Add("Abhijit");
            lst.Add("Manimoy");
            lst.Add("Raj");
            lst.Add("Ayan");
            lst.Add("MacMillanRojer");
            lst.Add("Rizzuto");
            IEnumerable<int> arr = Documented.GetValuesUpto(10);
            foreach (int i in arr)
                MessageBox.Show(i.ToString());


            foreach (string x in lst)
            {
                if (x.Length > 12) // Breaks on MacMillanRojer
                {
                    MessageBox.Show(arr.ToList<int>().Count.ToString());
                    yield break;
                }
                else if (x.Length > 5) // Only returns those which are having length >5
                    yield return x;
                else continue;
            }
        }

        public static IEnumerable Power(int number, int exponent)
        {
            int counter = 0;
            int result = 1;
            while (counter++ < exponent)
            {
                result = result * number;
                yield return result;
            }
        }

        public static IEnumerable<int> GetValuesUpto(int n)
        {

            for (int ctr = 1; ctr <= n; ctr++)
            {

                yield return ctr;
            }
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FixedTest();
        }
        public unsafe void FixedTest()
        {

            int[] a = new int[] { 1, 2, 3 };
            fixed (int* pt = a)
            {
                int* c = pt;
                MessageBox.Show("Value : " + *c);
                // This will fix the variable totally so that it will not be moved when Garbage collector is invoked. 
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                int x = int.MaxValue;
                int y = int.MaxValue;
                int z = checked(x + y);
                MessageBox.Show("Value of Z for checked is : " + z.ToString());
            }
            catch (StackOverflowException ex)
            {
                MessageBox.Show("Error Occurred: " + ex.Message);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                int x = int.MaxValue;
                int y = int.MaxValue;
                int z = unchecked(x + y);
                MessageBox.Show("Value of Z for checked is : " + z.ToString());
            }
            catch (StackOverflowException ex)
            {
                MessageBox.Show("Error Occurred: " + ex.Message);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            Thread th = new Thread(new ThreadStart(VolatileInvoke));
            th.Start();
            Thread.Sleep(5000); //Holds current Thread for 5 seconds.
            MessageBox.Show("Value of i : " + i);
            th.Abort();
        }
        private void VolatileInvoke()
        {
            while (true)
            {
                i++;
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            CreateArray();
        }
        private unsafe void CreateArray()
        {
            int* array = stackalloc int[1000];
            MessageBox.Show("High speed 1000 int array is created");
        }

        private void button7_Click(object sender, EventArgs e)
        {
            Array arr = new int[50];
            MessageBox.Show(arr.Length.ToString()); //Returns 50
            //If you open the below code arr.Length will show 1000
        }

        private void button8_Click(object sender, EventArgs e)
        {
            // Abhishek namespace leads to System.Drawing. See the using Alias statement in the header.
            Abhishek.Graphics g = this.CreateGraphics();
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int @int = 10;
            MessageBox.Show("Variable int have value = " + @int.ToString());
        }

        private void button10_Click(object sender, EventArgs e)
        {
            // this.readsecond = 40; - You cannot do this, after constructor is assinged, it cant be modified.

            MessageBox.Show("Value of Readonly field is : " + this.readsecond.ToString());
        }

        private void button11_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Default of CHAR : " + this.GetDefault<char>().ToString()); // Shows Empty
            MessageBox.Show("Default of CHAR : " + this.GetDefault<int>().ToString()); //Shows 0
            MessageBox.Show("Default of CHAR : " + this.GetDefault<object>().ToString()); // Shows Null --- Gives error as tostring cannot be applied. 
        }

        public T GetDefault<T>()
        {
            return default(T);
        }

        private void button12_Click(object sender, EventArgs e)
        {
            int? integervalue = null;
            MessageBox.Show(integervalue.HasValue.ToString());
        }


    }
    /*internal class System
    {
        internal class Array :IEnumerable 
        {
            public int Length
            {
                get{return 1000}
            }
            #region IEnumerable Members

            public IEnumerator GetEnumerator()
            {
                Debug.Write("This is Dummy Array");
                this.GetEnumerator();
            }

            #endregion
        }
    }*/
}
